#include<stdio.h>
#include<stdlib.h>

int main(int argc, char **argv[])
{
  char InFile[255], OutFile[255];
  int SizeOfFile, Temp1, Temp2, i=0;
  FILE *fp1;
  FILE *fp2;

  if(argv[1] == NULL)
  {
    printf("Memory addresses remover for Lyra executables v0.1 by Marton (marton@mail.com)\n\n");
    printf("This will remove all \"$$xx\" bytes from the executables, it may corrupt the exes\n");
    printf("because it will remove the following 2 bytes from anything that begins with $$\n");
    printf("but anyway it should be enough for getting a pure binary.\n");
    printf("Hope it helps somehow... :)");

    printf("\n\nBrief usage:\n");
    printf("exerem <infile> [outfile]\n");
    exit(1);
  }
  else
    sprintf(InFile,"%s", argv[1]);

  if(argv[2] == NULL)
  {
    printf("\nNo output file specified, using default name \"output.dat\"\n");
    sprintf(OutFile,"output.dat",0);
  }
  else
    sprintf(OutFile,"%s", argv[2]);


  if((fp1 = fopen(InFile, "rb")) == NULL)
  {
    printf("Error opening input file");
    exit(1);
  }

  if((fp2 = fopen(OutFile, "wb")) == NULL)
    printf("Can't create output file");

  fseek(fp1, 1, SEEK_END);
  SizeOfFile = i = (ftell(fp1));
  fseek(fp1, 0, SEEK_SET);
  printf("\nThe size of the file to \"pack\" is %d bytes\n", SizeOfFile-1);
  while(!feof(fp1))
  {
    printf("Working... %d    \r", i--);

    Temp1 = Temp2 = 0;  
    Temp1 = fgetc(fp1);

    if(Temp1 == 36)
      Temp2 = fgetc(fp1);
    else if(!feof(fp1))
    {
      fputc(Temp1, fp2);
    }

    if(((Temp1 == 36) && (Temp2 != 36)) && !feof(fp1))
    {
      fputc(Temp1, fp2);
      fputc(Temp2, fp2);
    }

    if((Temp1 == 36) && (Temp2 == 36))
    {
      fgetc(fp1);
      fgetc(fp1);
    }
  }
  fclose(fp1);
  fclose(fp2);
  printf("Working... 0        ");
  printf("\nDone!");
}
